[IOI2008]Island

2024-08-23 16:08
文章标签 island ioi2008

本文主要是介绍[IOI2008]Island,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目地址


思路:

  • 无向基环树森林求直径和。
  • 对于每颗基环树,它对答案的贡献只有可能经过环或不经过,分类讨论即可。
  • 首先处理出每个点往下的最大深度,顺便进行树形DP,再用单调队列获取经过环时的答案即可。
  • 最终树形DP与单调队列的结果取max即可。
  • (注意内存,数组需要使用技巧二次利用)

 (该代码内存超限)

#pragma GCC diagnostic error "-std=c++14"
#pragma GCC optimize ("O3")
#include<cstdio>
#include<iostream>
#include<queue>
#include<vector>
#include<cstring>
using namespace std;
const int MAXN=2000020,MAXM=1000010;
int n;
struct Edge{int from,to,w,nxt;
}e[MAXN];
int head[MAXN],edgeCnt=1,degree[MAXN];
void addEdge(int u,int v,int w){e[++edgeCnt].from=u;e[edgeCnt].to=v;e[edgeCnt].w=w;e[edgeCnt].nxt=head[u];head[u]=edgeCnt;
}
queue<int> topoQueue;
void topoSort(){for(int i=1;i<=n;i++)if(degree[i]==1)topoQueue.push(i);while(!topoQueue.empty()){int nowV=topoQueue.front();topoQueue.pop();for(int i=head[nowV];i;i=e[i].nxt){int v=e[i].to;degree[v]--,degree[nowV]--;if(degree[v]==1)topoQueue.push(v);}}
}
bool First_vis_circle[MAXN];
deque<int> First_circles[MAXN];int First_circleCnt=0;
long long First_dist[MAXN];
void First_find_Circle(int x,long long dis){First_vis_circle[x]=1;First_dist[x]=dis;First_circles[First_circleCnt].push_back(x);for(int i=head[x];i;i=e[i].nxt){int v=e[i].to;if(!First_vis_circle[v]&&degree[v]>=2){First_find_Circle(v,e[i].w+dis);}}
}
bool Second_vis_circle[MAXN];
long long Second_dist[MAXN];
deque<int> Second_circles[MAXN];int Second_circleCnt=0;
void Second_find_Circle(int x,long long dis,bool isFirst){Second_vis_circle[x]=1;Second_dist[x]=dis;Second_circles[Second_circleCnt].push_back(x);for(int i=head[x];i;i=e[i].nxt){int v=e[i].to;if(!Second_vis_circle[v]&&degree[v]>=2){if(isFirst){isFirst=false;continue;}Second_find_Circle(v,e[i].w+dis,0);}}
}
long long d[MAXN];
bool vis_dp[MAXN];
long long ans[MAXN],nowRoot=0;
long long circle_deep_ans[MAXN]; 
void dfs_dp(int x,int in_edge,int in_circle){vis_dp[x]=1;for(int i=head[x];i;i=e[i].nxt){ if(i==(in_edge^1))continue;int v=e[i].to;if(degree[v]<2&&(!vis_dp[v])){dfs_dp(v,i,in_circle);ans[x]=max(ans[x],d[x]+d[v]+e[i].w);circle_deep_ans[in_circle]=max(circle_deep_ans[in_circle],ans[x]);d[x]=max(d[x],d[v]+e[i].w);}}
}
int First_a[MAXN],First_endIndex=0;
int First_q[MAXN];
long long First_ans_point_to_point[MAXN],First_ans_point_to_pointCnt=0;
int Second_a[MAXN],Second_endIndex=0;
int Second_q[MAXN];
long long Second_ans_point_to_point[MAXN],Second_ans_point_to_pointCnt=0;
long long across_ans[MAXN];//直径 
long long total_across_ans=0;
int main(){memset(across_ans,0xcf,sizeof(across_ans));scanf("%d",&n);for(int i=1;i<=n;i++){int v,w;scanf("%d%d",&v,&w);addEdge(i,v,w);addEdge(v,i,w);degree[v]++;degree[i]++;}topoSort();for(int i=1;i<=n;i++){if(!First_vis_circle[i]&&degree[i]>=2){First_circleCnt++;First_find_Circle(i,0);}}for(int i=1;i<=n;i++){if(!Second_vis_circle[i]&&degree[i]>=2){Second_circleCnt++;Second_find_Circle(i,0,1);}}for(int i=1;i<=First_circleCnt;i++){int first=First_endIndex+1,size=First_circles[i].size();First_endIndex=first+2*size-1;int nowIndex=first;while(!First_circles[i].empty()){int nowV=First_circles[i].front();First_circles[i].pop_front();dfs_dp(nowV,0,i);First_a[nowIndex]=nowV;First_a[nowIndex+size]=nowV;nowIndex++;First_endIndex=nowIndex;}int l,r;First_q[l=r=1]=first;First_ans_point_to_pointCnt++;for(int j=first+1;j<=First_endIndex;j++){while(l<r&&j-First_q[l]>=size)l++;First_ans_point_to_point[First_ans_point_to_pointCnt]=max(First_ans_point_to_point[First_ans_point_to_pointCnt],d[First_a[j]]+d[First_a[First_q[l]]]+First_dist[First_a[j]]-First_dist[First_a[First_q[l]]]);while(l<r&&d[First_q[r]]-First_dist[First_q[r]]<d[First_a[j]]-First_dist[First_a[j]])r--;First_q[++r]=j;}}for(int i=1;i<=Second_circleCnt;i++){int first=Second_endIndex+1,size=Second_circles[i].size();Second_endIndex=first+2*size-1;int nowIndex=first;while(!Second_circles[i].empty()){int nowV=Second_circles[i].front();Second_circles[i].pop_front();dfs_dp(nowV,0,i);Second_a[nowIndex]=nowV;Second_a[nowIndex+size]=nowV;nowIndex++;Second_endIndex=nowIndex;}int l,r;Second_q[l=r=1]=first;Second_ans_point_to_pointCnt++;for(int j=first+1;j<=Second_endIndex;j++){while(l<r&&j-Second_q[l]>=size)l++;Second_ans_point_to_point[Second_ans_point_to_pointCnt]=max(Second_ans_point_to_point[Second_ans_point_to_pointCnt],d[Second_a[j]]+d[Second_a[Second_q[l]]]+Second_dist[Second_a[j]]-Second_dist[Second_a[Second_q[l]]]);while(l<r&&d[Second_a[Second_q[r]]]-Second_dist[Second_a[Second_q[r]]]<d[Second_a[j]]-Second_dist[Second_a[j]])r--;Second_q[++r]=j;}}for(int i=1;i<=First_ans_point_to_pointCnt;i++){across_ans[i]=max(across_ans[i],First_ans_point_to_point[i]);}long long trueAns=0;for(int i=1;i<=Second_ans_point_to_pointCnt;i++){across_ans[i]=max(across_ans[i],Second_ans_point_to_point[i]);trueAns+=max(across_ans[i],circle_deep_ans[i]);}cout<<trueAns<<endl;return 0;
}

 

这篇关于[IOI2008]Island的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1099858

相关文章

[LeetCode] 695. Max Area of Island

题:https://leetcode.com/problems/max-area-of-island/description/ 题目 Given a non-empty 2D array grid of 0’s and 1’s, an island is a group of 1’s (representing land) connected 4-directionally (horizont

[LightOJ 1265] Island of Survival (概率)

LightOJ - 1265 一个岛上有若干只虎,若干只鹿,一个人 每天只有两个动物会相见 如果人和虎相见,人死 如果鹿和虎相见,鹿死 如果虎和虎相见,虎死 其他情况均没有伤亡,各种情况均等概率 问人活到虎全死光的概率有多少 感觉二维dp直接搞正确性很显然 但是网上有另一种做法,就是直接忽略掉鹿的存在,当没有鹿 不是很懂这样做的正确性,网上的解释是鹿吃与被吃, 与人

HDU4280 Island Transport【最大流】【SAP】

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=4280 题目大意: 有N个岛屿,M条双向道路。每条路每小时最多能通过Ci个人。给你N个岛屿的坐标。问:一个小时内, 最多能将多少游客从最西边的岛送至最东边的岛屿上。 思路: 网络流求最大流的裸题。先通过坐标找到最西边的岛屿和最东边的岛屿,记录并标记为源点和汇点。然后 用链式

USACO2013 island travels

题意:一个R行C列的矩阵,'X'表示地,'S'表示浅水,'.'表示不能走的深水。连通的X视为一个岛(不超过15个)。现在要走完所有岛,求最少的踩在浅水格子的次数。 题解:岛屿不超过15个,明显的暗示可以用状态压缩DP跑旅行商问题。但是这题需要较多的预处理。首先给每个X连通块标上岛屿的序号,然后对每一个岛屿,将它直接相邻的浅水格子压入队列跑BFS即可求出所有岛屿到他的距离。然后记得一定要跑一次Fl

zoj 3810 A Volcanic Island(构造)

题目链接:zoj 3810 A Volcanic Island 题目大意:给定n,要求用n块面积为n的拼图铺满n∗n的矩阵,任意两块拼图形状不能相同(包括旋转和镜像),并且n块拼图只能有4中颜色,相邻两块拼图颜色不能相同。 解题思路:构造,n = 2,3,4时是不存在的。然后对于n >= 5的直接构造,具体看代码。注意这种构造方式构造6的时候会出现相同的拼图,所以特判。 #includ

hdu 4640 Island and study-sister(最短路+状压dp)

题目链接:hdu 4640 Island and study-sister 解题思路 用二进制数表示2~n的点是否移动过的状态, dp[s][i] dp[s][i]表示状态s上的点必须经过并且当前在i节点的最小代价, 这步用类似最短路的方式求出。 然后是 dp2[i][s] dp2[i][s]表示i个人移动过s状态的点的最小代价。 代码 #include <cstdio>#includ

HDU 4280 Island Transport 网络流

题意:给你一些点,自己找最左边的点为起点,最右边的点位终点,给你边的权值,求最大流,dinic就可以过。 思路:dinic,建无向图,正反向flow一样。 #pragma comment(linker,"/STACK:1024000000,1024000000")#include<iostream>#include<cstdio>#include<cstring>#inclu

[leetcode] max-area-of-island

. - 力扣(LeetCode) 给你一个大小为 m x n 的二进制矩阵 grid 。 岛屿 是由一些相邻的 1 (代表土地) 构成的组合,这里的「相邻」要求两个 1 必须在 水平或者竖直的四个方向上 相邻。你可以假设 grid 的四个边缘都被 0(代表水)包围着。 岛屿的面积是岛上值为 1 的单元格的数目。 计算并返回 grid 中最大的岛屿面积。如果没有岛屿,则返回面积为 0 。

【启发】leetcode - 695. Max Area of Island【回溯法 + 图的遍历 】

题目 Given a non-empty 2D array grid of 0's and 1's, an island is a group of 1's (representing land) connected 4-directionally (horizontal or vertical.) You may assume all four edges of the grid are

LeetCode-Island_Perimeter

题目: You are given a map in form of a two-dimensional integer grid where 1 represents land and 0 represents water. Grid cells are connected horizontally/vertically (not diagonally). The grid is comp